extern WORD     gwDevFuncNum;

extern DWORD    gdwPCISlot;

extern BYTE     gbPCIBios;

#define _INTA   0x0A
#define _INTB   0x0B
#define _INTC   0x0C
#define _INTD   0x0D

struct  _ROUTINGTABLE    {
    BYTE    bPCIBusNum;
    BYTE    bPCIDevNum;

    BYTE    bINTALink;
    WORD    wIRQAMap;

    BYTE    bINTBLink;
    WORD    wIRQBMap;

    BYTE    bINTCLink;
    WORD    wIRQCMap;

    BYTE    bINTDLink;
    WORD    wIRQDMap;

    BYTE    bDevSlot;

    BYTE    bReserved;
    };

typedef struct _ROUTINGTABLE ROUTINGTABLE;
typedef struct _ROUTINGTABLE *PROUTINGTABLE;
typedef struct _ROUTINGTABLE far *LPROUTINGTABLE;

struct  _ROUTINGHEADER  {
    WORD    wRoutingTableLength;
    LPROUTINGTABLE	lpRoutingTableBuffer;
    };
    
typedef struct _ROUTINGHEADER   ROUTINGHEADER;
typedef struct _ROUTINGHEADER   *PROUTINGHEADER;
typedef struct _ROUTINGHEADER	far *LPROUTINGHEADER;


int iGetPCIBios( void );
int iFindPCIDevice( WORD _wDeviceID, WORD _wVendorID );

int iSetPCIInterruptRouting( WORD _wDevFunc, BYTE _bInterruptPin, BYTE _bIRQLine  );
int iGetPCIInterruptRouting( PROUTINGHEADER _pRoutingTableHeader );

DWORD   dwRdPCISlot( BYTE _bSlot );

void	vWrPCIRegIndex( DWORD _dwPCIRegIndex );
DWORD	dwRdPCIRegIndex( void );

void    vWrPCIRegData( DWORD _dwPCIRegData );
DWORD	dwRdPCIRegData( void );

void    vWrPCIReg( DWORD _dwPCIRegIndex, DWORD _dwPCIRegData );
DWORD   dwRdPCIReg( DWORD _dwPCIRegIndex );
	
void    vSetPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit );
void    vMskPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit );
BYTE    bTstPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit );


